Data - Download Preview
Data Download API
Applies to: S1 pricing tier.
This API allows the caller to download a previously uploaded data content.
You can use this API in a scenario like downloading an existing collection of geofences uploaded previously using the Data Upload API for use in our Azure Maps Geofencing Service.
Submit Download Request
To download your content you will use a GET request where the path will contain the udid of the data to download. Optionally, you can also pass in an Accept header to specify a preference for the Content-Type of the data response.
For example, to download a collection of geofences previously uploaded using the Upload API, set the udid parameter in the path to the udid of the data received previously in the upload API response and set the Accept header to either one of the following media types:
application/jsonapplication/vnd.geo+jsonapplication/octet-stream
Download Data Response
The Download API will return a HTTP 200 OK response if the data resource with the passed-in udid is found, where the response body will contain the content of the data resource.
A HTTP 400 Bad Request error response will be returned if the data resource with the passed-in udid is not found.
Here's a sample response body for a simple geofence represented in GeoJSON uploaded previously using the Upload API:
{
"type": "FeatureCollection",
"features": [{
"type": "Feature",
"geometry": {
"type": "Point",
"coordinates": [-122.126986, 47.639754]
},
"properties": {
"geometryId": "001",
"radius": 500
}
}]
}
GET https://{geography}.atlas.microsoft.com/mapData/{udid}?api-version=1.0
GET https://{geography}.atlas.microsoft.com/mapData/{udid}?subscription-key={subscription-key}&api-version=1.0
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
geography
|
path | True |
|
This parameter specifies where the Azure Maps Creator resource is located. Valid values are us and eu. |
|
udid
|
path | True |
|
The unique data id for the content. The |
|
api-version
|
query | True |
|
Version number of Azure Maps API. Current version is 1.0 |
|
subscription-key
|
query |
|
One of the Azure Maps keys provided from an Azure Map Account. Please refer to this article for details on how to manage authentication. |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| x-ms-client-id |
|
Specifies which account is intended for usage in conjunction with the Azure AD security model. It represents a unique ID for the Azure Maps account and can be retrieved from the Azure Maps management plane Account API. To use Azure AD security in Azure Maps see the following articles for guidance. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
|
Data download request completed successfully. The response body will contain the content for the passed in Headers
|
| 400 Bad Request |
Bad request: one or more parameters were incorrectly specified or are mutually exclusive. |
|
| 401 Unauthorized |
Access denied due to invalid subscription key or invalid Azure Active Directory (Azure AD) bearer token. Make sure to provide a valid key for an active Azure subscription and Maps resource. Otherwise, verify the WWW-Authenticate header for error code and description of the provided Azure AD bearer token. Headers
|
|
| 403 Forbidden |
Permission, capacity, or authentication issues. |
|
| 404 Not Found |
Not Found: the requested resource could not be found, but it may be available again in the future. |
|
| 500 Internal Server Error |
An error occurred while processing the request. Please try again later. |
Security
AADToken
These are the Azure Active Directory OAuth2 Flows. When paired with Azure role-based access control it can be used to control access to Azure Maps REST APIs. Azure role-based access controls are used to designate access to one or more Azure Maps resource account or sub-resources. Any user, group, or service principal can be granted access via a built-in role or a custom role composed of one or more permissions to Azure Maps REST APIs.
To implement scenarios, we recommend viewing authentication concepts. In summary, this security definition provides a solution for modeling application(s) via objects capable of access control on specific APIs and scopes.
Notes
- This security definition requires the use of the
x-ms-client-idheader to indicate which Azure Maps resource the application is requesting access to. This can be acquired from the Maps management API.
The Authorization URL is specific to the Azure public cloud instance. Sovereign clouds have unique Authorization URLs and Azure Active directory configurations.
*
The Azure role-based access control is configured from the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
*
Usage of the Azure Maps Web SDK allows for configuration based setup of an application for multiple use cases.
- Currently, Azure Active Directory v1.0 or v2.0 supports Work, School, and Guests but does not support Personal accounts.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| https://atlas.microsoft.com/.default | https://atlas.microsoft.com/.default |
subscription-key
This is a shared key that is provisioned when creating an Azure Maps resource through the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
With this key, any application is authorized to access all REST APIs. In other words, these can currently be treated as master keys to the account which they are issued for.
For publicly exposed applications, our recommendation is to use server-to-server access of Azure Maps REST APIs where this key can be securely stored.
Type:
apiKey
In:
query
SAS Token
This is a shared access signature token is created from the List SAS operation on the Azure Maps resource through the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
With this token, any application is authorized to access with Azure role-based access controls and fine-grain control to the expiration, rate, and region(s) of use for the particular token. In other words, the SAS Token can be used to allow applications to control access in a more secured way than the shared key.
For publicly exposed applications, our recommendation is to configure a specific list of allowed origins on the Map account resource to limit rendering abuse and regularly renew the SAS Token.
Type:
apiKey
In:
header
Examples
Download previously uploaded GeoJSON data containing geometries that represent a collection of geofences
Sample Request
GET https://us.atlas.microsoft.com/mapData/25084fb7-307a-4720-8f91-7952a0b91012?subscription-key=[subscription-key]&api-version=1.0
Sample Response
{
"type": "FeatureCollection",
"features": [
{
"type": "Feature",
"geometry": {
"type": "Point",
"coordinates": [
-122.126986,
47.639754
]
},
"properties": {
"geometryId": "001",
"radius": 500
}
}
]
}
{
"error": {
"code": "400 BadRequest",
"message": "Bad request: one or more parameters were incorrectly specified or are mutually exclusive."
}
}
{
"error": {
"code": "401 Unauthorized",
"message": "Access denied due to invalid subscription key. Make sure to provide a valid key for an active subscription."
}
}
{
"error": {
"code": "403 Forbidden",
"message": "Permission, capacity, or authentication issues."
}
}
{
"error": {
"code": "404 NotFound",
"message": "Not Found: the requested resource could not be found, but it may be available again in the future."
}
}
{
"error": {
"code": "500 InternalServerError",
"message": "An error occurred while processing the request. Please try again later."
}
}
Definitions
|
OData |
This object is returned when an error occurs in the Azure Maps API. |
|
OData |
This response object is returned when an error occurs in the Azure Maps API. |
ODataError
This object is returned when an error occurs in the Azure Maps API.
| Name | Type | Description |
|---|---|---|
| code |
|
The ODataError code. |
| details |
This object is returned when an error occurs in the Azure Maps API. |
|
| message |
|
If available, a human-readable description of the error. |
| target |
|
If available, the target causing the error. |
ODataErrorResponse
This response object is returned when an error occurs in the Azure Maps API.
| Name | Type | Description |
|---|---|---|
| error |
This object is returned when an error occurs in the Azure Maps API. |